]> git.ipfire.org Git - people/ms/network.git/blame - src/network
reset: Destroy all IPsec VPN connections
[people/ms/network.git] / src / network
CommitLineData
5b20e43a
MT
1#!/bin/bash
2###############################################################################
3# #
4# IPFire.org - A linux based firewall #
1848564d 5# Copyright (C) 2010 Michael Tremer & Christian Schmidt #
5b20e43a
MT
6# #
7# This program is free software: you can redistribute it and/or modify #
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation, either version 3 of the License, or #
10# (at your option) any later version. #
11# #
12# This program is distributed in the hope that it will be useful, #
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
18# along with this program. If not, see <http://www.gnu.org/licenses/>. #
19# #
20###############################################################################
21
1848564d
MT
22# Parse the command line
23while [ $# -gt 0 ]; do
24 case "${1}" in
25 -d|--debug)
26 DEBUG=1
5b20e43a 27 ;;
1848564d
MT
28 *)
29 action=${1}
5b20e43a 30 ;;
5b20e43a 31 esac
5b20e43a 32 shift
1848564d 33 [ -n "${action}" ] && break
5b20e43a
MT
34done
35
3647b19f
MT
36. /usr/lib/network/functions
37
e9df08ad
MT
38# Read network settings
39network_settings_read
fe52c5e0 40
1c6a4e30 41cli_settings() {
9111eb72 42 if cli_help_requested $@; then
e9df08ad 43 cli_show_man network-settings
9111eb72
MT
44 exit ${EXIT_OK}
45 fi
46
47 if [ -n "${1}" ]; then
cfa738f1 48 network_settings_set $@
e9df08ad 49 network_settings_write
9111eb72 50 else
e9df08ad 51 network_settings_print
9111eb72
MT
52 fi
53}
54
1c6a4e30 55cli_device() {
6c74a64c
MT
56 if cli_help_requested $@; then
57 cli_show_man network-device
58 exit ${EXIT_OK}
59 fi
60
f90dd58c
MT
61 local action="${1}"
62 shift
ec63256a 63
9111eb72 64 case "${action}" in
f90dd58c
MT
65 list)
66 cli_device_list $@
5cf0edf9 67 ;;
9111eb72 68 *)
f90dd58c
MT
69 local device="${action}"
70 action="${1}"
71 shift
72
73 if ! isset device; then
74 cli_show_man network-device
75 return ${EXIT_ERROR}
76 fi
77
78 assert device_exists ${device}
79
80 case "${action}" in
81 discover)
82 cli_device_discover ${device} $@
83 ;;
f5ee091e
MT
84 identify)
85 device_identify "${device}" $@
86 ;;
f90dd58c
MT
87 monitor)
88 cli_device_monitor "${device}" $@
89 ;;
90 status)
91 cli_device_status ${device}
92 ;;
93 unlock)
94 cli_device_serial_unlock ${device} $@
95 ;;
96 ussd)
97 cli_device_send_ussd_command "${device}" $@
98 ;;
99 *)
100 cli_show_man network-device
101 ;;
102 esac
9111eb72
MT
103 ;;
104 esac
ec63256a
MT
105
106 return ${EXIT_OK}
107}
108
1c6a4e30 109cli_device_status() {
f90dd58c
MT
110 local device="${1}"
111 assert isset device
ec63256a 112
6c74a64c
MT
113 # Disable debugging output here.
114 local log_disable_stdout=${LOG_DISABLE_STDOUT}
115 LOG_DISABLE_STDOUT="true"
116
ec63256a
MT
117 # Save the type of the device for later.
118 local type=$(device_get_type ${device})
119
120 cli_headline 1 "Device status: ${device}"
121 cli_print_fmt1 1 "Name" "${device}"
122
f90dd58c
MT
123 # Handle special devices
124 case "${type}" in
125 phy)
126 cli_device_status_phy "${device}"
127 return $?
128 ;;
129 serial)
130 cli_device_status_serial "${device}"
131 return $?
132 ;;
133 esac
6c74a64c 134
ec63256a
MT
135 # Print the device status.
136 device_is_up ${device} &>/dev/null
137 local status=$?
138
139 case "${status}" in
140 ${EXIT_TRUE})
fcbf6823 141 status="${CLR_GREEN_B}UP${CLR_RESET}"
ec63256a
MT
142 ;;
143 ${EXIT_FALSE})
fcbf6823 144 status="${CLR_RED_B}DOWN${CLR_RESET}"
ec63256a
MT
145 ;;
146 esac
147
148 cli_print_fmt1 1 "Status" "${status}"
149 cli_print_fmt1 1 "Type" "${type}"
a4f7ad26
MT
150
151 # Ethernet-compatible?
152 device_is_ethernet_compatible "${device}" &>/dev/null
153 cli_print_fmt1 1 "Ethernet-compatible" "$(cli_print_bool $?)"
154
ec63256a
MT
155 cli_print_fmt1 1 "Address" "$(device_get_address ${device})"
156 cli_space
157
158 # Print the link speed for ethernet devices.
245dffc9 159 if device_is_up ${device} &>/dev/null; then
657540d8
MT
160 local link="$(device_get_link_string "${device}")"
161 if isset link; then
162 cli_print_fmt1 1 "Link" "${link}"
163 fi
245dffc9 164 fi
ec63256a
MT
165
166 cli_print_fmt1 1 "MTU" "$(device_get_mtu ${device})"
167 cli_space
168
3cb2fc42
MT
169 # Print device statistics.
170 cli_device_stats 2 ${device}
ec63256a
MT
171
172 # Print some more information.
173 device_has_carrier ${device} &>/dev/null
174 cli_print_fmt1 1 "Has carrier?" "$(cli_print_bool $?)"
175
176 device_is_promisc ${device} &>/dev/null
177 cli_print_fmt1 1 "Promisc" "$(cli_print_bool $?)"
6529dfaa
MT
178
179 # Supports multiqueue?
180 if device_supports_multiqueue ${device}; then
6655d1bf 181 cli_print_fmt1 1 "Multiqueue" "Supported"
6529dfaa 182 fi
ec63256a
MT
183 cli_space
184
6529dfaa
MT
185 cli_device_show_queues 2 ${device}
186
7951525a
MT
187 # Print all vlan devices.
188 local vlans=$(device_get_vlans ${device})
189 if [ -n "${vlans}" ]; then
190 cli_headline 2 "VLAN devices"
191
192 local vlan
193 for vlan in ${vlans}; do
194 cli_print 2 "* %-6s - %s" "${vlan}" "$(device_get_address ${vlan})"
ec63256a
MT
195 done
196 cli_space
197 fi
198
f90dd58c
MT
199 case "${type}" in
200 wireless*)
201 local phy="$(device_get_phy "${device}")"
202 if isset phy; then
203 cli_headline 2 "PHY"
204 cli_print_fmt1 2 "Name" "${phy}"
205 cli_print_fmt1 2 "Address" "$(phy_get_address "${phy}")"
206 cli_space
207 fi
208 ;;
209 esac
210
6c74a64c
MT
211 # Reset the logging level.
212 LOG_DISABLE_STDOUT=${log_disable_stdout}
213}
214
1c6a4e30 215cli_device_status_serial() {
6c74a64c
MT
216 local device=${1}
217 assert device_is_serial ${device}
218
219 serial_is_locked ${device} &>/dev/null
220 local locked=$?
221
222 cli_print_fmt1 1 "Locked" "$(cli_print_bool ${locked})"
223 cli_space
224
225 # Cannot go on when the device is locked.
226 [ ${locked} -eq ${EXIT_TRUE} ] && return ${EXIT_OK}
227
228 cli_print_fmt1 1 "Manufacturer" \
229 "$(modem_get_manufacturer ${device})"
230 cli_print_fmt1 1 "Model" \
231 "$(modem_get_model ${device})"
232 cli_print_fmt1 1 "Software version" \
233 "$(modem_get_software_version ${device})"
234
36aeb387
MT
235 # Mobile
236 if modem_is_mobile "${device}"; then
6c74a64c
MT
237 cli_print_fmt1 1 "IMEI" \
238 "$(modem_get_device_imei ${device})"
6c74a64c
MT
239 fi
240 cli_space
36aeb387
MT
241
242 if modem_is_mobile "${device}"; then
243 modem_mobile_network_status "${device}" 2
244 cli_space
245 fi
9111eb72
MT
246}
247
1c6a4e30 248cli_device_status_phy() {
f90dd58c
MT
249 local phy="${1}"
250 assert phy_exists "${phy}"
251
252 local address="$(phy_get_address "${phy}")"
253 cli_print_fmt1 1 "Address" "${address}"
254 cli_space
255
256 local devices="$(phy_get_devices "${phy}")"
257 if isset devices; then
258 cli_headline 2 "Soft interfaces"
259
260 local device
261 for device in ${devices}; do
262 cli_print 2 "* %s" "${device}"
263 done
264 cli_space
265 fi
266
267 return ${EXIT_OK}
268}
269
1c6a4e30 270cli_device_discover() {
9111eb72
MT
271 local device=${1}
272 shift
273
5dfc94a8
MT
274 # This can only be executed for ethernet (or compatible) devices
275 if ! device_is_ethernet_compatible "${device}"; then
9111eb72
MT
276 return ${EXIT_OK}
277 fi
278
279 local raw
280
281 while [ $# -gt 0 ]; do
282 case "${1}" in
283 --raw)
284 raw=1
285 ;;
286 esac
287 shift
288 done
289
290 local up
291 device_is_up ${device} && up=1
292 device_set_up ${device}
293
294 enabled raw || echo "${device}"
295
296 local hook
297 local out
298 local ret
299 for hook in $(hook_zone_get_all); do
300 out=$(hook_zone_exec ${hook} discover ${device})
301 ret=$?
302
303 [ ${ret} -eq ${DISCOVER_NOT_SUPPORTED} ] && continue
304
305 if enabled raw; then
306 case "${ret}" in
307 ${DISCOVER_OK})
308 echo "${hook}: OK"
309 local line
310 while read line; do
311 echo "${hook}: ${line}"
312 done <<<"${out}"
313 ;;
314
315 ${DISCOVER_ERROR})
316 echo "${hook}: FAILED"
317 ;;
318 esac
319 else
320 case "${ret}" in
321 ${DISCOVER_OK})
322 echo " ${hook} was successful."
323 local line
324 while read line; do
325 echo " ${line}"
326 done <<<"${out}"
327 ;;
328
329 ${DISCOVER_ERROR})
330 echo " ${hook} failed."
331 ;;
332 esac
333 fi
334 done
335
336 echo # New line
337
338 [ "${up}" = "1" ] || device_set_down ${device}
339}
340
1c6a4e30 341cli_device_serial_unlock() {
6c74a64c
MT
342 if cli_help_requested $@; then
343 cli_show_man network-device
344 exit ${EXIT_OK}
345 fi
346
347 local device=${1}
348 assert isset device
349
350 if ! device_is_serial ${device}; then
351 error "${device} is not a serial device."
352 error "Unlocking is only supported for serial devices."
353 exit ${EXIT_ERROR}
354 fi
355
356 # Read the current state of the SIM card.
357 modem_sim_status ${device} &>/dev/null
358 local sim_status_code=$?
359
360 # If the SIM card is already unlocked, we don't need to do anything.
361 if [ ${sim_status_code} -eq ${EXIT_SIM_READY} ]; then
362 print "The SIM card is already unlocked."
363 exit ${EXIT_OK}
364
365 # If the SIM card is in an unknown state, we cannot do anything.
366 elif [ ${sim_status_code} -eq ${EXIT_SIM_UNKNOWN} ]; then
367 error "The SIM card is in an unknown state."
368 exit ${EXIT_ERROR}
369 fi
370
371 # Ask for the code.
372 local code=${2}
373 local require_new_pin="false"
374 local new_pin
375
376 while ! isinteger code; do
377 local message
378 case "${sim_status_code}" in
379 ${EXIT_SIM_PIN})
380 message="Please enter PIN:"
381 ;;
382 ${EXIT_SIM_PUK})
383 message="Please enter PUK:"
384 require_new_pin="true"
385 ;;
386 esac
387 assert isset message
388
389 echo -n "${message} "
390 read -s code
391 echo # Print newline.
392
393 if enabled require_new_pin; then
394 local i new_pin2
395 for i in 0 1; do
396 case "${i}" in
397 0)
398 message="Please enter a new PIN code:"
399 ;;
400 1)
401 message="Please confirm the new PIN code:"
402 ;;
403 esac
404
405 echo -n "${message} "
406 read -s new_pin2
407 echo # Print newline.
408
409 if [ -n "${new_pin}" ]; then
410 if [ "${new_pin}" != "${new_pin2}" ]; then
411 error "The entered PIN codes did not match."
412 exit ${EXIT_ERROR}
413 fi
414 else
415 new_pin=${new_pin2}
416 fi
417 done
418 fi
419 done
420
421 # Trying to unlock the SIM card.
422 modem_sim_unlock ${device} ${code} ${new_pin}
423
424 exit $?
425}
426
1c6a4e30 427cli_device_send_ussd_command() {
5cf0edf9
MT
428 local device="${1}"
429 assert isset device
430 shift
431
432 local command
433 local timeout
434
435 while [ $# -gt 0 ]; do
436 case "${1}" in
437 --timeout=*)
438 timeout="$(cli_get_val "${1}")"
439 ;;
440 *)
441 if isset command; then
442 warning "Unrecognized argument: ${1}"
443 else
444 command="${1}"
445 fi
446 ;;
447 esac
448 shift
449 done
450
451 assert device_is_serial "${device}"
452
453 local args
454 if isset timeout; then
455 args="${args} --timeout=${timeout}"
456 fi
457
458 modem_ussd_send_command "${device}" "${command}" ${args}
459 exit $?
460}
461
1c6a4e30 462cli_device_monitor() {
5a38ea84
MT
463 local device="${1}"
464 assert isset device
465
466 if ! device_is_wireless "${device}"; then
467 error "This action only works with wireless devices. Exiting."
468 exit ${EXIT_ERROR}
469 fi
470
471 wireless_monitor "${device}"
472 exit $?
473}
474
1c6a4e30 475cli_device_list() {
f90dd58c
MT
476 local device
477 for device in $(device_list); do
478 cli_device_status "${device}"
479 done
480
481 exit ${EXIT_OK}
482}
483
1c6a4e30 484cli_hostname() {
9111eb72
MT
485 if cli_help_requested $@; then
486 cli_show_man network
487 exit ${EXIT_OK}
488 fi
489
490 local hostname=${1}
491
492 if [ -n "${hostname}" ]; then
493 config_hostname ${hostname}
494 log INFO "Hostname was set to '${hostname}'."
495 log INFO "Changes do only take affect after reboot."
496 exit ${EXIT_OK}
497 fi
498
499 echo "$(config_hostname)"
500 exit ${EXIT_OK}
501}
502
1c6a4e30 503cli_port() {
9111eb72
MT
504 if cli_help_requested $@; then
505 cli_show_man network-port
506 exit ${EXIT_OK}
507 fi
508
509 local action
510 local port
511
512 if port_exists ${1}; then
513 port=${1}
514 action=${2}
515 shift 2
516
9111eb72 517 case "${action}" in
f5ee091e 518 edit|create|remove|up|down|status|identify)
1ba6a2bb 519 port_${action} "${port}" $@
9111eb72 520 ;;
8de0a49f
JS
521 color)
522 color_cli "port" "${port}" $@
523 ;;
ba348e4b
JS
524 description)
525 description_cli "port" "${port}" $@
526 ;;
9111eb72
MT
527 *)
528 error "Unrecognized argument: ${action}"
529 exit ${EXIT_ERROR}
530 ;;
531 esac
532 else
533 action=${1}
534 shift
535
536 case "${action}" in
1ba6a2bb 537 new|destroy)
9111eb72
MT
538 port_${action} $@
539 ;;
540 *)
541 error "Unrecognized argument: ${action}"
542 exit ${EXIT_ERROR}
543 ;;
544 esac
545 fi
546}
547
1c6a4e30 548cli_zone() {
9111eb72
MT
549 if cli_help_requested $@; then
550 cli_show_man network-zone
551 exit ${EXIT_OK}
552 fi
553
554 local action
555 local zone
556
9ea45130 557 if zone_exists ${1}; then
9111eb72
MT
558 zone=${1}
559 action=${2}
560 shift 2
561
562 # Action aliases
563 case "${action}" in
e6fd23fd 564 start|reload)
9111eb72
MT
565 action="up"
566 ;;
567 stop)
568 action="down"
569 ;;
570 show)
571 action="status"
572 ;;
573 esac
574
575 case "${action}" in
ac694a6a
MT
576 port)
577 cli_zone_port "${zone}" $@
578 ;;
2bb20bbd
SS
579 rename)
580 cli_zone_rename "${zone}" $@
581 ;;
f5ee091e 582 config|disable|down|edit|enable|identify|status|up)
9111eb72
MT
583 zone_${action} ${zone} $@
584 ;;
8de0a49f
JS
585 color)
586 color_cli "zone" "${zone}" $@
587 ;;
ba348e4b
JS
588 description)
589 description_cli "zone" ${zone} $@
590 ;;
9111eb72
MT
591 *)
592 error "Unrecognized argument: ${action}"
593 cli_show_man network-zone
594 exit ${EXIT_ERROR}
595 ;;
596 esac
597 else
598 action=${1}
599 shift
600
601 case "${action}" in
cf0fc8ab 602 new)
2c37b88b 603 cli_zone_new $@
9111eb72 604 ;;
cf0fc8ab
MT
605 destroy)
606 cli_zone_destroy $@
9111eb72 607 ;;
9111eb72
MT
608 ""|*)
609 if [ -n "${action}" ]; then
610 error "Unrecognized argument: '${action}'"
611 echo
612 fi
613
614 cli_show_man network-zone
615 exit ${EXIT_ERROR}
616 ;;
617 esac
618 fi
619}
620
2c37b88b
MT
621cli_zone_new() {
622 if cli_help_requested $@ || [ $# -lt 2 ]; then
623 cli_show_man network-zone-new
624 exit ${EXIT_OK}
625 fi
626
627 zone_new $@
628}
629
9111eb72
MT
630# Removes a zone either immediately, if it is currently down,
631# or adds a tag that the removal will be done when the zone
632# is brought down the next time.
1c6a4e30 633cli_zone_destroy() {
9111eb72
MT
634 if cli_help_requested $@; then
635 cli_show_man network-zone
636 exit ${EXIT_OK}
637 fi
638
cf0fc8ab
MT
639 local zone="${1}"
640 assert zone_exists "${zone}"
9111eb72
MT
641
642 if zone_is_up ${zone}; then
643 echo "Zone '${zone}' is up and will be removed when it goes down the next time."
cf0fc8ab 644 zone_destroy "${zone}"
9111eb72
MT
645 else
646 echo "Removing zone '${zone}' now..."
cf0fc8ab 647 zone_destroy_now "${zone}"
9111eb72
MT
648 fi
649
650 exit ${EXIT_OK}
651}
652
1c6a4e30 653cli_zone_port() {
ac694a6a
MT
654 if cli_help_requested $@; then
655 cli_show_man network-zone-port
656 exit ${EXIT_OK}
657 fi
658
659 local zone="${1}"
660 assert zone_exists "${zone}"
661
662 if port_exists "${2}"; then
663 local port="${2}"
664 local action="${3}"
665 shift 3
666
667 case "${action}" in
668 edit)
669 zone_port_edit "${zone}" "${port}" $@
670 ;;
671 *)
672 error "Unrecognised argument: ${action}"
673 exit ${EXIT_ERROR}
674 ;;
675 esac
676 else
677 local action="${2}"
678 shift 2
679
680 case "${action}" in
681 attach)
682 zone_port_attach "${zone}" $@
683 ;;
684 detach)
685 zone_port_detach "${zone}" $@
686 ;;
687 *)
688 error "Unrecognised argument: ${action}"
689 exit ${EXIT_ERROR}
690 ;;
691 esac
692 fi
693
694 exit ${EXIT_OK}
695}
696
2bb20bbd
SS
697cli_zone_rename() {
698 if cli_help_requested $@; then
699 cli_show_man network-zone
700 exit ${EXIT_OK}
701 fi
702
703 local zone="${1}"
704 local name="${2}"
705 shift 2
706
707 if ! isset name; then
708 error "You need to pass a new name"
709 exit ${EXIT_ERROR}
710 fi
711
712 if ! zone_name_is_valid "${name}"; then
713 error "Invalid new zone name: ${name}"
714 exit ${EXIT_ERROR}
715 fi
716
717 # Check if the zone exists
718 if ! zone_exists "${zone}"; then
719 error "Zone ${zone} does not exist"
720 exit ${EXIT_ERROR}
721 fi
722
723 # Destroyed zones cannot be renamed
724 if zone_has_destroy_tag "${zone}"; then
725 error "Zone ${zone} is about to be destroyed and cannot be renamed"
726 exit ${EXIT_ERROR}
727 fi
728
729 # Check if a zone with the new name already exists
730 if zone_exists "${name}"; then
731 error "Zone ${name} already exists"
732 exit ${EXIT_ERROR}
733 fi
734
735 # Rename
736 if ! zone_rename "${zone}" "${name}"; then
737 error "Could not rename zone ${zone} to ${name}"
738 exit ${EXIT_ERROR}
739 fi
740
741 exit ${EXIT_OK}
742}
743
1c6a4e30 744cli_list_hooks() {
9111eb72
MT
745 local type=${1}
746 shift
747
748 if cli_help_requested $@; then
749 cli_show_man network-zone
750 exit ${EXIT_OK}
751 fi
752
753 local hook_dir=$(hook_dir ${type})
754 local hook
755
756 for hook in ${hook_dir}/*; do
757 hook=$(basename ${hook})
758 if hook_exists ${type} ${hook}; then
759 echo "${hook}"
760 fi
761 done | sort -u
762}
763
1c6a4e30 764cli_dhcpd() {
6c07160e
MT
765 local proto=${1}
766 shift
767
768 if cli_help_requested $@; then
769 cli_show_man network-dhcp
770 exit ${EXIT_OK}
771 fi
772
773 local action=${1}
774 shift
775
776 case "${action}" in
777 edit)
778 dhcpd_edit ${proto} $@
779 ;;
780 start)
781 dhcpd_start ${proto}
9ff233f0
MT
782
783 # Make this permanent
784 dhcpd_enable ${proto}
6c07160e
MT
785 ;;
786 stop)
787 dhcpd_stop ${proto}
9ff233f0
MT
788
789 # Make this permanent
790 dhcpd_disable ${proto}
6c07160e
MT
791 ;;
792 restart|reload)
793 dhcpd_reload ${proto}
794 ;;
795 subnet)
796 cli_dhcpd_subnet ${proto} $@
797 ;;
798 show|"")
799 cli_dhcpd_show ${proto} $@
800 ;;
801 *)
802 error "Unrecognized action: ${action}"
803 cli_run_help network dhcpvN
804
805 exit ${EXIT_ERROR}
806 ;;
807 esac
808
809 exit ${EXIT_OK}
810}
811
1c6a4e30 812cli_dhcpd_show() {
6c07160e
MT
813 local proto=${1}
814 assert isset proto
815
816 local settings=$(dhcpd_settings ${proto})
817 assert isset settings
818
819 local ${settings}
820 dhcpd_global_settings_read ${proto}
821
822 cli_headline 1 "Dynamic Host Configuration Protocol Daemon for ${proto/ip/IP}"
823
824 case "${proto}" in
825 ipv6)
826 cli_headline 2 "Lease times"
827 if isinteger VALID_LIFETIME; then
d13929d4 828 cli_print_fmt1 2 "Valid lifetime" "$(format_time ${VALID_LIFETIME})"
6c07160e
MT
829 fi
830
831 if isinteger PREFERRED_LIFETIME; then
d13929d4 832 cli_print_fmt1 2 "Preferred lifetime" "$(format_time ${PREFERRED_LIFETIME})"
6c07160e
MT
833 fi
834
835 cli_space
836 ;;
837 ipv4)
838 cli_print_fmt1 1 "Authoritative" $(cli_print_enabled AUTHORITATIVE)
839 cli_space
840
841 cli_headline 2 "Lease times"
d13929d4
MT
842 cli_print_fmt1 2 "Default lease time" "$(format_time ${DEFAULT_LEASE_TIME})"
843 cli_print_fmt1 2 "Max. lease time" "$(format_time ${MAX_LEASE_TIME})"
6c07160e
MT
844
845 if isset MIN_LEASE_TIME; then
d13929d4 846 cli_print_fmt1 2 "Min. lease time" "$(format_time ${MIN_LEASE_TIME})"
6c07160e
MT
847 fi
848
849 cli_space
850 ;;
851 esac
852
853 # Read the options.
854 local -A options
6a9a9ea6 855 dhcpd_global_options_read ${proto}
6c07160e
MT
856
857 # Print the options if any.
858 if [ ${#options[*]} -gt 0 ]; then
859 cli_headline 2 "Options"
860
861 local option
862 for option in $(dhcpd_options ${proto}); do
863 [ -n "${options[${option}]}" ] || continue
864
865 cli_print_fmt1 2 \
866 "${option}" "${options[${option}]}"
867 done
868 cli_space
869 fi
870
871 # Subnets.
872 local subnets=$(dhcpd_subnet_list ${proto})
873 if [ -n "${subnets}" ]; then
874 cli_headline 2 "Subnets"
6a9a9ea6
MT
875 local subnet
876 for subnet in ${subnets}; do
877 cli_dhcpd_subnet_show ${proto} ${subnet} 2
6c07160e
MT
878 done
879 fi
880}
881
1c6a4e30 882cli_dhcpd_subnet() {
6a9a9ea6
MT
883 assert [ $# -ge 1 ]
884
6c07160e
MT
885 local proto=${1}
886 shift
887
888 if cli_help_requested $@; then
889 cli_show_man network-dhcp-subnet
890 exit ${EXIT_OK}
891 fi
892
893 local action=${1}
894 shift
895
896 case "${action}" in
897 new)
898 dhcpd_subnet_new ${proto} $@
899 ;;
900 remove)
901 dhcpd_subnet_remove ${proto} $@
902 ;;
6a9a9ea6
MT
903 *:*/*|*.*.*.*/*)
904 local subnet=${action}
6c07160e 905
6a9a9ea6
MT
906 if ! dhcpd_subnet_exists ${proto} ${subnet}; then
907 error "Subnet ${subnet} does not exist"
6c07160e
MT
908 return ${EXIT_ERROR}
909 fi
910
911 # Update the action.
912 action=${1}
913 shift
914
915 case "${action}" in
916 edit)
6a9a9ea6 917 dhcpd_subnet_edit ${proto} ${subnet} $@
6c07160e
MT
918 local ret=$?
919
920 if [ ${ret} -eq ${EXIT_OK} ]; then
921 dhcpd_reload ${proto}
922 fi
923 exit ${ret}
924 ;;
925 range)
6a9a9ea6 926 cli_dhcpd_subnet_range ${proto} ${subnet} $@
6c07160e
MT
927 exit $?
928 ;;
929 show)
6a9a9ea6 930 cli_dhcpd_subnet_show ${proto} ${subnet} $@
6c07160e
MT
931 exit $?
932 ;;
933 options)
6a9a9ea6 934 cli_dhcpd_subnet_options ${proto} ${subnet} $@
6c07160e
MT
935 exit $?
936 ;;
937 *)
938 error "Unrecognized action: ${action}"
939 cli_run_help network dhcpvN subnet
940 exit ${EXIT_ERROR}
941 ;;
942 esac
943 ;;
944 show)
6a9a9ea6
MT
945 local subnet
946 for subnet in $(dhcpd_subnet_list ${proto}); do
947 cli_dhcpd_subnet_show ${proto} ${subnet}
6c07160e
MT
948 done
949 ;;
950 *)
951 error "Unrecognized action: ${action}"
952 cli_run_help network dhcpvN subnet
953
954 exit ${EXIT_ERROR}
955 ;;
956 esac
957
958 exit ${EXIT_OK}
959}
960
1c6a4e30 961cli_dhcpd_subnet_range() {
6a9a9ea6 962 assert [ $# -ge 2 ]
6c07160e 963
6a9a9ea6
MT
964 local proto=${1}
965 local subnet=${2}
966 local action=${3}
967 shift 3
6c07160e
MT
968
969 case "${action}" in
970 new)
6a9a9ea6 971 dhcpd_subnet_range_new ${proto} ${subnet} $@ || exit ${EXIT_ERROR}
6c07160e
MT
972 ;;
973 remove)
6a9a9ea6 974 dhcpd_subnet_range_remove ${proto} ${subnet} $@ || exit ${EXIT_ERROR}
6c07160e
MT
975 ;;
976 *)
977 error "Unrecognized action: ${action}"
978 cli_run_help network dhcpvN subnet range
979 exit ${EXIT_ERROR}
980 ;;
981 esac
90b63fca
MT
982
983 dhcpd_reload ${proto}
984 return ${EXIT_OK}
6c07160e
MT
985}
986
1c6a4e30 987cli_dhcpd_subnet_show() {
6a9a9ea6 988 assert [ $# -ge 2 -a $# -le 3 ]
6c07160e 989
6a9a9ea6
MT
990 local proto=${1}
991 local subnet=${2}
6c07160e
MT
992
993 local level=${3}
994 isset level || level=0
995
996 local $(dhcpd_subnet_settings ${proto})
997
998 # Read in configuration settings.
6a9a9ea6 999 dhcpd_subnet_read ${proto} ${subnet}
6c07160e 1000
94784eb9 1001 cli_headline $(( ${level} + 1 )) "DHCP Subnet Declaration"
6c07160e
MT
1002 cli_print_fmt1 $(( ${level} + 1 )) \
1003 "Subnet" "${ADDRESS}/${PREFIX}"
1004 cli_space
1005
1006 # Read the options.
1007 local -A options
6a9a9ea6 1008 dhcpd_subnet_options_read "${proto}" "${subnet}"
6c07160e
MT
1009
1010 # Print the options if any.
1011 if [ ${#options[*]} -gt 0 ]; then
1012 cli_headline $(( ${level} + 2 )) "Options"
1013
1014 local option
cc02f6be 1015 for option in $(dhcpd_subnet_options_list ${proto}); do
6c07160e
MT
1016 [ -n "${options[${option}]}" ] || continue
1017
1018 cli_print_fmt1 $(( ${level} + 2 )) \
1019 "${option}" "${options[${option}]}"
1020 done
1021 cli_space
1022 fi
1023
1024 # Ranges.
1025 cli_headline $(( ${level} + 2 )) "Ranges"
1026
6a9a9ea6 1027 local ranges=$(dhcpd_subnet_range_list ${proto} ${subnet})
6c07160e 1028 if isset ranges; then
f3ac1159
MT
1029 local range $(dhcpd_subnet_range_settings ${proto})
1030 for range in ${ranges}; do
6a9a9ea6 1031 dhcpd_subnet_range_read ${proto} ${subnet} ${range}
6c07160e 1032
f3ac1159 1033 cli_print $(( ${level} + 2 )) "%s - %s" ${START} ${END}
6c07160e
MT
1034 done
1035 else
1036 cli_print $(( ${level} + 2 )) "No ranges have been defined."
1037 fi
1038
1039 cli_space
1040}
1041
1c6a4e30 1042cli_dhcpd_subnet_options() {
6a9a9ea6 1043 assert [ $# -eq 2 ]
6c07160e 1044
6a9a9ea6
MT
1045 local proto=${1}
1046 local subnet=${2}
6c07160e 1047
6c07160e
MT
1048 local key val
1049 while [ $# -gt 0 ]; do
1050 case "${1}" in
1051 *=*)
1052 key=$(cli_get_key ${1})
1053 val=$(cli_get_val ${1})
1054
6a9a9ea6 1055 dhcpd_subnet_option_set ${proto} ${subnet} ${key} ${val}
6c07160e
MT
1056 esac
1057 done
1058}
1059
1c6a4e30 1060cli_start() {
9111eb72
MT
1061 if cli_help_requested $@; then
1062 cli_show_man network
1063 exit ${EXIT_OK}
1064 fi
1065
1066 local zones=$(zones_get $@)
1067
1068 local zone
1069 for zone in ${zones}; do
1070 zone_start ${zone} &
1071 done
1072
1073 wait # until everything is settled
1074}
1075
1c6a4e30 1076cli_stop() {
9111eb72
MT
1077 if cli_help_requested $@; then
1078 cli_show_man network
1079 exit ${EXIT_OK}
1080 fi
1081
1082 local zones=$(zones_get $@)
1083
1084 local zone
1085 for zone in ${zones}; do
1086 zone_stop ${zone} &
1087 done
1088
1089 wait # until everything is settled
1090}
1091
1c6a4e30 1092cli_restart() {
9111eb72
MT
1093 if cli_help_requested $@; then
1094 cli_show_man network
1095 exit ${EXIT_OK}
1096 fi
1097
1098 cli_stop $@
1099
1100 # Give the system some time to calm down
1101 sleep ${TIMEOUT_RESTART}
1102
1103 cli_start $@
1104}
1105
1c6a4e30 1106cli_status() {
9111eb72
MT
1107 if cli_help_requested $@; then
1108 cli_show_man network
1109 exit ${EXIT_OK}
1110 fi
1111
1112 # When dumping status information, the debug
1113 # mode clutters the console which is not what we want.
1114 # Logging on the console is disabled for a short time.
1115 local log_disable_stdout=${LOG_DISABLE_STDOUT}
1116 LOG_DISABLE_STDOUT="true"
1117
1118 local zones=$(zones_get $@)
1119
1120 local zone
1121 for zone in ${zones}; do
1122 zone_status ${zone}
1123 done
1124
1125 # Reset logging.
1126 LOG_DISABLE_STDOUT=${log_disable_stdout}
1127}
1128
1c6a4e30 1129cli_reset() {
9111eb72
MT
1130 if cli_help_requested $@; then
1131 cli_show_man network
1132 exit ${EXIT_OK}
1133 fi
1134
1135 warning_log "Will reset the whole network configuration!!!"
9111eb72
MT
1136 # Force mode is disabled by default
1137 local force=0
1138
1139 while [ $# -gt 0 ]; do
1140 case "${1}" in
1141 --force|-f)
1142 force=1
1143 ;;
1144 esac
1145 shift
1146 done
1147
1148 # If we are not running in force mode, we ask the user if he does know
1149 # what he is doing.
1150 if ! enabled force; then
1151 if ! cli_yesno "Do you really want to reset the whole network configuration?"; then
1152 exit ${EXIT_ERROR}
1153 fi
1154 fi
1155
f5f9014d
MT
1156 # Destroy all IPsec VPN connections
1157 local connection
1158 for connection in $(ipsec_list_connections); do
1159 ipsec_connection_destroy "${connection}"
1160 done
1161
1162 # Stop strongswan
1163 ipsec_strongswan_autostart
1164
9111eb72
MT
1165 local zone
1166 for zone in $(zones_get --all); do
cf0fc8ab 1167 zone_destroy_now "${zone}"
9111eb72
MT
1168 done
1169
1170 local port
1171 for port in $(ports_get --all); do
1ba6a2bb 1172 port_destroy "${port}"
9111eb72
MT
1173 done
1174
acc9efd5
MT
1175 # Flush all DNS servers.
1176 dns_server_flush
1177
9111eb72
MT
1178 # Re-run the initialization functions
1179 init_run
1180
1181 exit ${EXIT_OK}
1182}
1183
85afd775
MT
1184# Help function: will show the default man page to the user.
1185# Optionally, there are two arguments taken, the type of hook
1186# and which hook should be shown.
1c6a4e30 1187cli_help() {
6b7654eb
MT
1188 local cmd=${1}
1189 shift
85afd775 1190
6b7654eb
MT
1191 case "${cmd}" in
1192 zone|port|config)
1193 local type=${cmd}
1194 local hook=${1}
1195
1196 # List all hooks if requested
1197 if [ "${hook}" = "list-hooks" ]; then
1198 cli_list_hooks ${type}
1199 return ${EXIT_OK}
1200 fi
85afd775 1201
6b7654eb
MT
1202 if ! hook_exists ${type} ${hook}; then
1203 error "No hook with name '${hook}' could be found"
1204 exit "${EXIT_ERROR}"
1205 fi
85afd775 1206
6b7654eb
MT
1207 hook_exec ${type} ${hook} help
1208 ;;
1209
1210 # In all other cases show the default man page
1211 *)
1212 cli_show_man network
1213 return ${EXIT_OK}
1214 ;;
1215 esac
85afd775 1216
6b7654eb 1217 return ${EXIT_ERROR}
85afd775
MT
1218}
1219
1c6a4e30 1220cli_dns_server() {
acc9efd5 1221 if cli_help_requested $@; then
6b34112f 1222 cli_show_man network-dns-server
acc9efd5
MT
1223 exit ${EXIT_OK}
1224 fi
1225
1226 # Get the command.
1227 local cmd=${1}; shift
1228 if [ -z "${cmd}" ]; then
6b34112f 1229 cli_show_man network-dns-server
acc9efd5
MT
1230 exit ${EXIT_ERROR}
1231 fi
1232
6f923dac
MT
1233 # Get the new server to process (if any).
1234 local server=${1}
1235 local priority=${2}
1236
acc9efd5
MT
1237 case "${cmd}" in
1238 list)
8d1d2745 1239 dns_server_show
e5efaa6b 1240 exit ${EXIT_OK}
acc9efd5
MT
1241 ;;
1242 add)
e5651e17
MT
1243 if dns_server_exists ${server}; then
1244 error "DNS server '${server}' already exists!"
1245 exit ${EXIT_ERROR}
1246 fi
1247
6f923dac
MT
1248 log INFO "Adding new DNS server: ${server}"
1249 dns_server_add ${server} ${priority}
acc9efd5
MT
1250 ;;
1251 remove)
e5651e17
MT
1252 if ! dns_server_exists ${server}; then
1253 error "DNS server '${server}' does not exist!"
1254 exit ${EXIT_ERROR}
1255 fi
1256
6f923dac
MT
1257 log INFO "Removing DNS server: ${server}"
1258 dns_server_remove ${server} ${priority}
acc9efd5
MT
1259 ;;
1260 update)
1261 # Just run the update afterwards.
1262 ;;
1263 *)
1264 error "No such command: ${cmd}"
1265 exit ${EXIT_ERROR}
1266 esac
1267
1268 # Update the local DNS configuration after changes have been made.
bf98f6fc 1269 dns_server_update
acc9efd5
MT
1270
1271 exit ${EXIT_OK}
1272}
1273
1c6a4e30 1274cli_raw() {
bae37360
MT
1275 local cmd="${1}"
1276 assert isset cmd
1277 shift
1278
1279 case "${cmd}" in
c041b631
MT
1280 db-dump)
1281 db_dump
1282 ;;
ac7ef1f9
JS
1283 ipsec-connection-exists)
1284 ipsec_connection_exists $@
1285 ;;
bae37360
MT
1286 list-devices)
1287 device_list
1288 ;;
cc02f6be
MT
1289 list-dhcpd-ranges-of-subnet)
1290 dhcpd_subnet_range_list $@
1291 ;;
1292 list-dhcpd-settings)
1293 dhcpd_global_settings_list $@
1294 ;;
1295 list-dhcpd-subnets)
1296 dhcpd_subnet_list $@
1297 ;;
1298 list-dhcpd-subnet-options)
1299 dhcpd_subnet_options_list $@
1300 ;;
8d1d2745
MT
1301 list-dns-servers)
1302 dns_server_list
1303 ;;
bae37360
MT
1304 list-free-ports)
1305 port_list_free
1306 ;;
1307 list-hooks)
1308 hook_list $@
1309 ;;
c87851b7
JS
1310 list-ipsec-connections)
1311 ipsec_list_connections
1312 ;;
bae37360
MT
1313 list-ports)
1314 port_list
1315 ;;
1316 list-ports-of-zone)
1317 zone_get_ports $@
1318 ;;
1d9c63f7
JS
1319 list-vpn-security-policies-all)
1320 vpn_security_policies_list_all
1321 ;;
bae37360
MT
1322 list-settings)
1323 network_settings_list
1324 ;;
1325 list-zones)
1326 zones_get_all
1327 ;;
1ca5fe9f
JS
1328 list-next-free-zones)
1329 zones_get_next_free
1330 ;;
9da14216
JS
1331 list-zone-config-ids)
1332 zone_config_list_ids $@
1333 ;;
a8be80ca
JS
1334 list-zone-config-hids)
1335 zone_config_list_hids $@
1336 ;;
51408ef7
JS
1337 vpn-security-policy-exists)
1338 vpn_security_policy_exists $@
1339 ;;
1ca5fe9f
JS
1340 zone-name-is-valid)
1341 zone_name_is_valid $@
1342 ;;
7deab7cc
JS
1343 zone-config-id-is-valid)
1344 zone_config_id_is_valid $@
1345 ;;
fbba9abf
JS
1346 zone-config-hid-is-valid)
1347 zone_config_hid_is_valid $@
1348 ;;
bae37360
MT
1349 *)
1350 error "No such command: ${cmd}"
1351 exit ${EXIT_ERROR}
1352 ;;
1353 esac
1354
1355 exit ${EXIT_OK}
1356}
1357
1848564d
MT
1358# Process the given action
1359case "${action}" in
b8357295
MT
1360 init)
1361 init_run
1362 ;;
1363
8bfdea7f 1364 settings|hostname|port|device|zone|start|stop|restart|status|reset|route|vpn)
0a79ea02 1365 cli_${action} $@
1848564d
MT
1366 ;;
1367
6c07160e
MT
1368 # DHCP server configuration (automatically detects which protocol to use).
1369 dhcpv6|dhcpv4)
1370 cli_dhcpd ${action/dhcp/ip} $@
1371 ;;
1372
6b34112f
MT
1373 # DNS server configuration.
1374 dns-server)
1375 cli_dns_server $@
1376 ;;
1377
fe4555b5 1378 ""|help|--help|-h)
85afd775 1379 cli_help $@
1848564d 1380 ;;
fe4555b5 1381
bae37360
MT
1382 raw)
1383 cli_raw $@
1384 ;;
1385
1848564d 1386 *)
fe4555b5 1387 error "Invalid command given: ${action}"
de28a630 1388 cli_usage "network help"
1848564d 1389 exit ${EXIT_CONF_ERROR}
fe4555b5 1390 ;;
1848564d 1391esac
85afd775
MT
1392
1393exit ${EXIT_OK}